Name: bash-completion
%define filename bash_completion
%define bashversion 2.05a
Summary: bash-completion offers programmable completion for bash %{bashversion}
Version: 20020121
Release: 1
Group: System Environment/Shells
License: GPL
Packager: Ian Macdonald <ian@caliban.org>
Source: %{filename}
BuildRoot: /var/tmp/%{name}-root
BuildArch: noarch
Requires: bash >= 2.05-12
Requires(post): grep

%description
bash-completion is a collection of shell functions that take advantage of
the programmable completion feature of bash 2.04 and later.

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}
install %{SOURCE0} $RPM_BUILD_ROOT%{_sysconfdir}

%clean
rm -rf $RPM_BUILD_ROOT

%post
if ! grep -q '\[ -f '%{_sysconfdir}'/bash_completion \]' \
     %{_sysconfdir}/bashrc 2>/dev/null; then
cat <<'EOF' >> %{_sysconfdir}/bashrc
if [ "$PS1" ] && [[ $BASH_VERSION == 2.05* ]] \
   && [ -f %{_sysconfdir}/bash_completion ]; then	# interactive shell
	# Source completion code
        . %{_sysconfdir}/bash_completion
fi
EOF
fi

%files
%defattr(644,root,root)
%{_sysconfdir}/bash_completion

%changelog
* Mon Jan 21 2002 Ian Macdonald <ian@caliban.org>
- fixed bug that caused ssh completion to go awry when hostname contained @
- rewrote command completion for commands like sudo, which should first
  complete on a command, then call that command's own completion function
- fixed _man() completion so that file completion on relative paths works

* Tue Jan 15 2002 Ian Macdonald <ian@caliban.org>
- added _mysqladmin() completion

* Wed Jan  9 2002 Ian Macdonald <ian@caliban.org>
- added _chgrp() completion
- added _ifupdown() for Red Hat Linux if{up,down} completion
- improve _iptables() with some chain name completion
- _cd() was no longer completing relative to $CDPATH

* Sat Jan  5 2002 Ian Macdonald <ian@caliban.org>
- fixed _cd() so that if $CDPATH is set and no completions are returned
  relative to its paths, directory completion relative to $PWD is performed
- fixed _cd() so that it completes on directories with an embedded space
- gv also completes on encapsulated PostScript files and PDF files
- jadetex and pdfjadetex added to commands that complete on tex files
- improved _tar() completion to handle .tgz and .tar files
- tar c*f performs file completion
- added 'conflicts' and 'obsoletes' query completions to _rpm()
- added 'repackage' completion option to rpm -[ei]
- fixed _file_and_dir() so that it completes on dirs with an embedded space

* Wed Jan  2 2002 Ian Macdonald <ian@caliban.org>
- check for location of showmount in _mount()
- condense awk|grep combo in _configure() to a single sed command
- change embedded tabs to $'\t' syntax
- be more intelligent about parsing for exclusion (-X) compspecs when
  binding commands to _file_and_dir()

* Thu Dec 20 2001 Ian Macdonald <ian@caliban.org>
- added meta-completion function _file_and_dir for compspecs requiring
  the -X flag. This allows us to exclude files without excluding directories.

* Mon Dec 17 2001 Ian Macdonald <ian@caliban.org>
- add ant and nslookup completion
- make xv and ee complete on more file types

* Mon Dec 10 2001 Ian Macdonald <ian@caliban.org>
- use type instead of which to determine what's on system
- require >= 2.05-12 to allow installation by people using patched 2.05

* Wed Dec  5 2001 Ian Macdonald <ian@caliban.org>
- removed misleading comment on _man completion
- use -g, not -u for group completion (duh!)
- avoid unnecessary use of $COMPREPLY_SAVE in _ssh/_scp
- use '-' as prefix (-P) to kill, not '%', and put it *before* command
- default to filename completion on _scp
- source ~/.bash_completion if it exists

* Wed Nov 28 2001 Ian Macdonald <ian@caliban.org>
- simplify code for group completion, since bash 2.05a has this built in
- now Requires bash 2.05a

* Mon Nov 26 2001 Ian Macdonald <ian@caliban.org>
- make _known_hosts escape meta-characters in path before handing off to awk
- added missing ` to _service

* Tue Nov 20 2001 Ian Macdonald <ian@caliban.org>
- default to _dirnames on _find
- fixed bug in _known_hosts that caused keys in known_hosts2 files to be
  returned as completions
- made _ssh a little more intelligent
- added _scp
- made _cd expand ~ in directory specs
- declared $i as a local variable in many functions

* Sun Nov  4 2001 Ian Macdonald <ian@caliban.org>
- rpm completion now uses /var/log/rpmpkgs if available, which makes some
  completions much more responsive on systems with large numbers of packages
- man completion now checks section 'l' of the manual

* Tue Oct 23 2001 Ian Macdonald <ian@caliban.org>
- add a Requires(post) for grep
- use -q with grep in %post
- use License instead of Copyright
- use macro in %post, rather than a direct reference to the file

* Fri Sep 21 2001 Ian Macdonald <ian@caliban.org>
- fix to _cd that prevented completions being returned when $CDPATH was
  not set and user was attempting to complete on a non-absolute path

* Wed Aug 22 2001 Ian Macdonald <ian@caliban.org>
- removed previous fix to _rpm, since it broke more than it fixed

* Thu Aug 16 2001 Ian Macdonald <ian@caliban.org>
- better Perforce completion from Frank Cusack <frank@google.com>
- _command meta-command completion from Frank Cusack <frank@google.com>
- bug fix to _rpm

* Thu Jul 12 2001 Ian Macdonald <ian@caliban.org>
- minor changes to p4 completion

* Tue Jul 10 2001 Ian Macdonald <ian@caliban.org>
- minor mod to cd completion to make absolute path completion work

* Mon Jul  9 2001 Ian Macdonald <ian@caliban.org>
- fixed bug in have() function that returned false positives
- made some of the default completions more sensible
- added basic Perforce completion

* Tue Jun 19 2001 Ian Macdonald <ian@caliban.org>
- added rudimentary tar, tcpdump and iptables completion functions
- added checking, so that functions are only defined on platforms that
  actually have the commands that will use them

* Mon May 21 2001 Ian Macdonald <ian@caliban.org>
- modified functions for 'complete -o', new in bash 2.05
- require bash instead of bash2

* Wed Jan 31 2001 Ian Macdonald <ian@caliban.org>
- man page completion performs filename completion if no /etc/man.config
- insmod completion wasn't completing module parameters properly
- modprobe -r now completes a la lsmod
- insmod completion now performs filename completion if module name contains /

* Wed Jan 10 2001 Ian Macdonald <ian@caliban.org>
- added Red Hat service completion

* Wed Dec 20 2000 Ian Macdonald <ian@caliban.org>
- added --rmsource as stand-alone option to RPM completion

* Tue Dec 19 2000 Ian Macdonald <ian@caliban.org>
- RPM file glob completion enhanced; bug fix to killall completion

* Mon Nov 20 2000 Ian Macdonald <ian@caliban.org>
- RPM completion updated for rpm 4.x, numerous bug fixes and extra options

* Sun Oct 29 2000 Ian Macdonald <ian@caliban.org>
- fixed bug in rpm completion that made -e, etc. not find all RPMs

* Thu Oct 19 2000 Ian Macdonald <ian@caliban.org>
- reverted cd, mkdir & pushd to standard -d directory completion

* Mon Oct  9 2000 Ian Macdonald <ian@caliban.org>
- minor improvements to _man & _find
- improved FreeS/WAN completion
- added Debian apt-get & apt-cache completion
- added more intelligent directory completion in new _directory function

* Mon Sep 25 2000 Ian Macdonald <ian@caliban.org>
- version set to 20000925
- insmod completion improved with parameter completion
- ssh completion broken up into _known_hosts function for use by other commands
- Makefile completion added

* Mon Sep 11 2000 Ian Macdonald <ian@caliban.org>
- update to 0.06
- fixed bug in man completion that caused pages with a dot (e.g. lilo.conf)
  not to be found
- ssh completion enhanced with command completion after host
- fixed bug in ssh completion that caused spurious completions when completing
  on an IP address
- added route(8) completion

* Tue Aug 29 2000 Ian Macdonald <ian@caliban.org>
- update to 0.05
- fixed bug in killall completion
- added cipher completion to -c option of ssh

* Mon Aug 28 2000 Ian Macdonald <ian@caliban.org>
- update to 0.04
- added ssh completion
- tidied the code in some other functions

* Fri Aug 11 2000 Ian Macdonald <ian@caliban.org>
- update to 0.03
- added cvs, rpm, chsh & chkconfig completion

* Wed Aug  2 2000 Ian Macdonald <ian@caliban.org>
- update to 0.02

* Sun Jul 29 2000 Ian Macdonald <ian@caliban.org>
- 0.01 packaged as RPM
